com.amazonaws.codegen.naming

## Interface NamingStrategy

All Known Implementing Classes:
  DefaultNamingStrategy

    public interface NamingStrategy

Strategy to name various Java constructs based on the naming in the model and potentially customizations.

### Method Summary

All Methods Instance Methods Abstract Methods
`String` `getEnumValueName(String enumValue)`
`String` `getExceptionName(String errorShapeName)`
`String` `getFluentSetterMethodName(String memberName)`
`String` `getGetterMethodName(String memberName)`
`String` `getJavaClassName(String shapeName)`
`String` `getRequestClassName(String operationName)`
`String` `getResponseClassName(String operationName)`
`String` `getSetterMethodName(String memberName)`
`String` `getVariableName(String name)`

### Method Detail

#### getExceptionName

    String getExceptionName(String errorShapeName)

Parameters:
  `errorShapeName` - Name of error shape to derive exception class name from.
Returns:
  Appropriate name to use for a Java exception class name

#### getRequestClassName

    String getRequestClassName(String operationName)

Parameters:
  `operationName` - Name of operation used to derive request class name.
Returns:
  Appropriate name to use for the Java class representing the request shape.

#### getResponseClassName

    String getResponseClassName(String operationName)

Parameters:
  `operationName` - Name of operation used to derive response class name.
Returns:
  Appropriate name to use for the Java class representing the response shape.

#### getVariableName

    String getVariableName(String name)

Parameters:
  `name` - Some contextual name to derive variable name from (i.e. member name, java class name, etc).
Returns:
  Appropriate name to use for a Java variable or field.

#### getEnumValueName

    String getEnumValueName(String enumValue)

Parameters:
  `enumValue` - Enum value as defined in the service model used to derive the java name.
Returns:
  Appropriate name to use for a Java enum value

#### getJavaClassName

    String getJavaClassName(String shapeName)

Parameters:
  `shapeName` - Name of structure used to derive Java class name.
Returns:
  Appropriate name to use for a Java class for an arbitrary (not a request, response, error) structure.

#### getGetterMethodName

    String getGetterMethodName(String memberName)

Parameters:
  `memberName` - Member name to name getter for.
Returns:
  Name of the getter method for a model class member.

#### getSetterMethodName

    String getSetterMethodName(String memberName)

Parameters:
  `memberName` - Member name to name setter for.
Returns:
  Name of the setter method for a model class member.

#### getFluentSetterMethodName

    String getFluentSetterMethodName(String memberName)

Parameters:
  `memberName` - Member name to name fluent setter for.
Returns:
  Appropriate name to use for fluent setter method (i.e. withFoo) for a model class member.